#property copyright "Md. Mahmudur Rahman"
#property link      ""
#import "stdlib.ex4"
   string ErrorDescription(int a0);
#import "kernel32.dll"

  void OutputDebugStringA(string msg); //used in log()
#import
//--- input parameters
extern bool      SendLogToDebugView=true;
extern int       SecBetwSendingLog=5;
extern double    LotSize=0.01;
extern double    StopLoss=15.0;
extern double    TakeProfit=20.0;
extern int       iMaxOrders=1;
extern int       Slippage=5;
extern int       MagicNumber=814;
extern double    Value_Diff= 0.01;
extern int       Fast_SMA_Value=10;
extern int       Slow_EMA_Value=20;
extern double    BreakEvenSL   =1;
extern double    BreakEven= 5.0;
extern double    TrailingStart=10.0;
extern double    TrailingStop=4.0;
extern double    TrailingStep=5.0;

extern int       iOrderType_Buy=0;
extern int       iOrderType_Sell=1;
extern bool      bWriteToDebugView=true;
extern bool      bShowDebugOnChart=true;

int BuyOrder;
int SellOrder;

int iOpenOrders_Sell;
int iOpenOrders_Buy;

int iLastError;


double dPip;
double dStopLossPrice, dTakeProfitPrice;

string sNL = " \n"; //new line
string sLogComment; //used for debugging using DebugView

string sLog_Start;
string sLog_CheckBuyConditions;
string sLog_CheckSellConditions;
string sLog_TrailOrder;
//+------------------------------------------------------------------+
#define MODE_DEMA    4
#define MODE_TEMA    5
#define MODE_T3MA    6
#define MODE_JMA     7
#define MODE_HMA     8
#define MODE_DECEMA  9
#define MODE_SALT    10
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
extern   int      MA_Period               = 10;
extern   int      MA_Type                 = MODE_HMA;
extern   int      MA_Applied              = PRICE_CLOSE;
extern   double   T3MA_VolumeFactor       = 0.8;
extern   double   JMA_Phase               = 0.0;
extern   int      Step_Period             = 1;
extern   bool     DebugMode               = false;
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

if(Digits==3){
	dPip = 0.01;
}else{
	dPip = 0.0001;
}

return(0);

}

int deinit()
{

Comment("");
return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



int start()
{
sLog_Start = "START - start() function----------------------------------";

double Fast_SMA, Slow_EMA, MA_Difference_1, MA_Difference_2,Value_Difference_1,Value_Difference_2;
bool bOrderClosed;

double Break_Even=BreakEven();
if(TrailingStop>0 && TrailingStart > 0) TrailOrder (TrailingStart, TrailingStop); 

sLog_Start = sLog_Start + sNL + "Setting Trailing Stops";

//count open buy orders.
iOpenOrders_Buy = CntOrd(iOrderType_Buy,MagicNumber,Symbol());

//count open sell orders.
iOpenOrders_Sell = CntOrd(iOrderType_Sell,MagicNumber,Symbol());

sLog_Start = sLog_Start + sNL + "    Start - Set and Get MA values";

//Slow_EMA = iMA(NULL,0,Fast_SMA_Value,0,MODE_LWMA,PRICE_OPEN,1);

//Fast_SMA = iMA(NULL,0,Fast_SMA_Value,0,MODE_LWMA,PRICE_MEDIAN,1);

//MA_Difference_1= Fast_SMA-Slow_EMA;

//MA_Difference_2= Slow_EMA-Fast_SMA;

double value1 = iCustom(NULL,0,"xpMA",MA_Period,MA_Type,MA_Applied ,T3MA_VolumeFactor,JMA_Phase,Step_Period,DebugMode,0,1); 
double value2 = iCustom(NULL,0,"xpMA",MA_Period,MA_Type,MA_Applied ,T3MA_VolumeFactor,JMA_Phase,Step_Period,DebugMode,0,2); 
double value3 = iCustom(NULL,0,"xpMA",MA_Period,MA_Type,MA_Applied ,T3MA_VolumeFactor,JMA_Phase,Step_Period,DebugMode,0,3); 
//if ((value1-value2)*(value2-value3)<0)
   //if (value1>value2)
         //slope changed to up
   //else  slope changed to down 

Value_Difference_1=value1-value2;    
Value_Difference_2=value2-value3;

sLog_Start = sLog_Start + sNL + "    Allowed MAX Orders =" +iMaxOrders;
sLog_Start = sLog_Start + sNL + "    First value 1 =" +value1;
sLog_Start = sLog_Start + sNL + "    Second value 2 =" +value2;
sLog_Start = sLog_Start + sNL + "    Third value 3 =" +value3;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";
sLog_Start = sLog_Start + sNL + "    VALUE DIFFERENCE:1=" + Value_Difference_1;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";
sLog_Start = sLog_Start + sNL + "    VALUE DIFFERENCE:2=" + Value_Difference_2;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";

if((Value_Difference_1*Value_Difference_2)<0)
{
if (value1>value2)
{
sLog_Start = sLog_Start + sNL + "    EA Should BUY Now" ;
}
else
{
sLog_Start = sLog_Start + sNL + "    EA Should SELL Now" ;
}
}
sLog_Start = sLog_Start + sNL + "    End - Set and Get MA values";
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";

sLog_CheckBuyConditions =  "    Start - Checking Buy condition----";

///////////////////////////// Checking Buying Condition
if((Value_Difference_1*Value_Difference_2)<0)
{
if (value1>value2)
{
sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy condition is met. Check order count----";
	
//Start - Close open sell positions------------------------------------------
//check if there are open sell positions.
	if(iOpenOrders_Sell > 0) {

	bOrderClosed = closeSellOrder(iOrderType_Sell); //Closing Sell order
	
		if(bOrderClosed){
			sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Sell Order Closed";
		
		}else{ //order was not closed.
			iLastError = GetLastError();
			sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Closing Sell Order failed. Error code = " + ErrorDescription(iLastError);
		}
	}//end if(iOpenOrders_Sell > 0) {
//End - Close open sell positions------------------------------------------
	
	if(iOpenOrders_Buy < iMaxOrders) { //////////////////////////////////////////5
		sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Open order count is OK. Send new BUY order";
		
		double OpenPrice=Ask;

		
		dStopLossPrice = NormalizeDouble(OpenPrice - StopLoss * dPip,Digits);
		dTakeProfitPrice = NormalizeDouble(OpenPrice + TakeProfit * dPip,Digits);
		

		BuyOrder=OrderSend(Symbol() , iOrderType_Buy , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice , "Buy Order",MagicNumber , 0,Blue);
		
		
		 if(BuyOrder>0) {
			//buy order sent successfully
				sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy order sent successfully. Ticket=" + BuyOrder;
				iLastError = 0;
			}
			else
			{
			
				iLastError = GetLastError();
				
				sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending buy order. Error code=" + ErrorDescription(iLastError);
			
			}// end else if(BuyOrder>0) 
	
}//end if(iOpenOrders_Buy < iMaxOrders) { /////////////////////////////////////5
	else{
		//max open order count has been reached. Do not open any additional orders.
		sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    The max allowed open order limit has already been reached.----";
		
	}//end else if(iOpenOrders_Buy < iMaxOrders) {


sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    End - Checking Buy condition----";
sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    --------------------------------";
}
else
///////////////////////////// Checking Selling Condition
{

sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Sell condition is met. Check order count----";

if(iOpenOrders_Buy > 0) {
		
		bOrderClosed = closeBuyOrder(iOrderType_Buy); //Closing Buy order
	
		if(bOrderClosed){
			sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Buy order is Closed";
		}else{
			iLastError = GetLastError();
			sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Closing Buy Order failed. Error code = " + ErrorDescription(iLastError);
		
		}//end else if(bOrderClosed){
	}//end if(iOpenOrders_Buy > 0) {
	
	if(iOpenOrders_Sell < iMaxOrders) { ////////////////////////////////////////////2
	
		OpenPrice=Bid;
		
		dStopLossPrice = NormalizeDouble(OpenPrice + StopLoss * dPip,Digits);
		dTakeProfitPrice = NormalizeDouble(OpenPrice - TakeProfit * dPip,Digits);

		SellOrder=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice , "Sell Order",MagicNumber , 0,Red);
		
		
		if(SellOrder>0) {
			//sell order sent successfully
				sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Sell order sent successfully. Ticket=" + SellOrder;
				iLastError = 0;
			}else{
				iLastError = GetLastError();
				
				sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Error sending Sell order. Error code=" + ErrorDescription(iLastError);
			
			}// end else if(SellOrder>0) 
		
	}//end if(iOpenOrders_Sell < iMaxOrders) { ////////////////////////////////////////2
		else{
			//max open order count has been reached. Do not open any additional orders.
			sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    The max allowed open order limit has already been reached.----";
				
		}//end else if(iOpenOrders_Sell < iMaxOrders) {
	
	
}//end if (Y4=1)/////////////////////////////////////////////1
sLogComment = sLogComment + sNL + "END - start() function--------------------------------";	
}



//send debug data to DebugView
if (bWriteToDebugView) {
	
	sLogComment = sLog_Start;
	sLogComment = sLogComment + sNL + sLog_TrailOrder;
	sLogComment = sLogComment + sNL + sLog_CheckBuyConditions;
	sLogComment = sLogComment + sNL + sLog_CheckSellConditions;
	
	log(sLogComment);
	
	Sleep(SecBetwSendingLog * 1000);
		
}//end if bWriteToDebugView {

//show debug data as comment
if (bShowDebugOnChart) { 
	Comment(sLogComment);
	
}//end if (bShowDebugOnChart) { 


return (0);

}

//////////////////////////////////////////////////////////////////// comparison

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void log(
   string s1,
   string s2 = "",
   string s3 = "",
   string s4 = "",
   string s5 = "",
   string s6 = "",
   string s7 = "",
   string s8 = ""
) 
{

  string out = StringTrimRight(StringConcatenate(
                                   WindowExpertName(), ".mq4 ", Symbol(),
                                   " ", s1,
                                   " ", s2,
                                   " ", s3,
                                   " ", s4,
                                   " ", s5,
                                   " ", s6,
                                   " ", s7,
                                   " ", s8
                                ));
   OutputDebugStringA(out);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CntOrd(int Type, int Magic, string Symb) {
//return number of orders matching the order type and symbol specific parameters. Magic number param is optional
int _CntOrd;
_CntOrd=0;
int iTotalOrders_;
iTotalOrders_ = OrdersTotal();

for(int i=iTotalOrders_;i>=0;i--)
{
   if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
 // Print("i=",i,"Symbol ", OrderSymbol(), " Order type= ", OrderType(), "Magic =", OrderMagicNumber()," ", Magic);
  
  
   if (OrderSymbol()==Symb) {
      if ( (OrderType()==Type && (OrderMagicNumber()==Magic) || Magic==0)) _CntOrd++;
         }
}
return(_CntOrd);
}//end int CntOrd(int Type, int Magic, string Symb) {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

string boolToString(bool BoolVar){

string sBoolString;

if(BoolVar==FALSE){
   sBoolString = "FALSE";
}else{
   sBoolString = "TRUE";
}

return(sBoolString);

}//end string boolToString(bool BoolVar)
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void TrailOrder(double Trailingstart,double Trailingstop){
int ticket = 0;

sLog_TrailOrder = "    Start - TrailOrder function--------------------";

double tStopLoss;

//tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. OrderSelect has to be run first before assinging a value to tStopLoss

int cnt;
double vPoint,vSlippage;

//double sl     = OrderStopLoss(); // Stop Loss. OrderSelect has to be run first before assinging a value to sl
double sl;


if (Digits == 3 || Digits == 5)
    {vPoint = Point * 10; vSlippage = Slippage * 10;    }
    else
    {vPoint = Point; vSlippage = Slippage;}

RefreshRates();
if(OrdersTotal()>0){

	for(cnt=OrdersTotal()-1;cnt>=0;cnt--){
	
	if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
		
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    Order selected. OrderTicket=" + OrderTicket();
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderStopLoss=" + DoubleToStr(OrderStopLoss(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderTakeProfit=" + DoubleToStr(OrderTakeProfit(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    ------------------------------";
	
		sl     = OrderStopLoss(); // Stop Loss. 
		tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. 
		
		if(OrderType()==OP_BUY){
		
			if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits)
			&& tStopLoss < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Ask=" + DoubleToStr(Ask,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStart=" + TrailingStart;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    vPoint=" + DoubleToStr(vPoint,6);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStop=" + TrailingStop;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStep=" + DoubleToStr(TrailingStep,Digits);
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    tStopLoss=" + DoubleToStr(tStopLoss,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits),Digits);
			
				tStopLoss = NormalizeDouble(Bid-TrailingStop*vPoint,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new tStopLoss=" + DoubleToStr(tStopLoss,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,Blue);

				if (ticket > 0){
					Print ("TrailingStop #2 Activated: ", OrderSymbol(), ": SL", tStopLoss, ": Bid", Bid);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(tStopLoss,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
			}//end if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits) && tStopLoss < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
		}//end if(OrderType()==OP_BUY){


		if (OrderType()==OP_SELL) {
			if (Bid < NormalizeDouble(OrderOpenPrice()-TrailingStart*vPoint,Digits)
			&& (sl >(NormalizeDouble(Ask+(TrailingStop+TrailingStep)*vPoint,Digits)))
			|| (OrderStopLoss()==0)){
			
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Bid=" + DoubleToStr(Bid,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Max Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()-TrailingStart* vPoint,Digits),Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    sl=" + DoubleToStr(sl,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Ask+(TrailingStop+TrailingStep)*vPoint,Digits),Digits);
				
				sl = NormalizeDouble(Ask+TrailingStop*vPoint,Digits);
								
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new sl=" + DoubleToStr(sl,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
				
				if (ticket > 0){
					Print ("Trailing #2 Activated: ", OrderSymbol(), ": SL ",sl, ": Ask ", Ask);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(sl,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
				}
			}


}//end for(cnt=OrdersTotal();cnt>=0;cnt--){
}//end if(OrdersTotal()>0){

sLog_TrailOrder = sLog_TrailOrder + sNL + "    End - TrailOrder function--------------------";

return;
}//end void TrailOrder(double Trailingstart,double Trailingstop){


//========================================================================================

bool closeBuyOrder(int iBuytype)
{
bool bClosed_;

if(OrdersTotal()>0)
{
for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
{
OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES);

if(iBuytype==OP_BUY && OrderType()==OP_BUY)
{
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
 {
RefreshRates();

OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits), Slippage);

}
}
}
}

return(bClosed_);
}//end bool closeBuyOrder(int iBuytype)
//==========================================================================================
double BreakEven()

{ double vPoint, vSlippage;
if (Digits == 3 || Digits == 5)
    {vPoint = Point * 10; vSlippage = Slippage * 10;    }
    else
    {vPoint = Point; vSlippage = Slippage;}
RefreshRates();
	for(int cnt = OrdersTotal()-1; cnt>=0 ; cnt--){
	
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==false)break;
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)continue;  {
      
	if(OrderType()==OP_BUY){
		 //--- check for breakeven  
            if(BreakEven>0)
              {
               if(Bid-OrderOpenPrice()>=vPoint*BreakEven)
                 {
                  if(OrderStopLoss()<OrderOpenPrice())
                    {
                     //--- modify order
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(BreakEvenSL*vPoint),OrderTakeProfit(),0,Green);
                    }
                 }
              }  
            }     
if (OrderType()==OP_SELL) {
		            //--- check for breakeven  
            if(BreakEven>0)
              {
               if(OrderOpenPrice()-Ask>vPoint*BreakEven)
                 {
                  if(OrderStopLoss()>OrderOpenPrice())
                    {
                     //--- modify order
                    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(BreakEvenSL*vPoint),OrderTakeProfit(),0,Green);
                    }
                 }
              }    
            }               
            //--- check for trailing stop
}
}
return;
}
//===========================================================================================

bool closeSellOrder(int iSelltype)
{
bool bClosed_;

	if(OrdersTotal()>0)
	{
		for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
		{
			if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES)) continue;

			if(iSelltype==OP_SELL && OrderType()==OP_SELL)
			{
				if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
				{
					RefreshRates(); 
					bClosed_ = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage);
				}//end if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
			}//end if(iSelltype==OP_SELL && OrderType()==OP_SELL)
		}//end for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
	}//end if(OrdersTotal()>0)
	
	
	return(bClosed_);
}//end bool closeSellOrder(int Selltype)